<template>
    <form @submit.prevent="submit()">
      <v-card>
        <v-card-title>
          <h2 class="subtitle-1">
            {{ role ? `Update` :`Record` }} role details
          </h2>
          <v-spacer></v-spacer>
          <v-btn
            icon
            small
            color="red"
            @click="$emit('closed')"
          >
            <v-icon small color="red">mdi-close</v-icon>
          </v-btn>
        </v-card-title>

        <v-divider></v-divider>

        <v-card-text class="pt-5">
          <v-text-field
            dense
            outlined
            persistent-hint
            class="body-2"
            label="Name"
            v-model="display_name"
          ></v-text-field>

          <v-textarea
            outlined
            class="body-2"
            label="Description"
            v-model="description"
          ></v-textarea>
        </v-card-text>

        <v-card-actions class="px-4 pb-5">
          <v-btn
            block
            large
            type="submit"
            color="primary"
            class="caption font-weight-bold no-transform"
            :dark="!loading"
            :loading="loading"
            :disabled="loading"
          >
            {{ role ? 'Update' : 'Save' }} Role Details
          </v-btn>
        </v-card-actions>
      </v-card>
    </form>
</template>

<script>
/* eslint-disable vue/no-mutating-props */
// eslint-disable-next-line import/extensions
// import Role from '../../../../libs/roles/Role';

export default {
  props: [
    'role',
    'dialog',
  ],

  data() {
    return {
      loading: false,
      // roleObj: new Role(),
      show: false,
      error: null,
      display_name: '',
      description: '',

    };
  },

  mounted() {
    const { role } = this;
    // this.setRoleObj(this.role);
  },

  computed: {
    // errors() {
    //   return this.roleObj.form.errors;
    // },

  },

  methods: {
    setRoleObj(role) {
      // if (role) {
      //   for (const index in role) {
      //     if (this.roleObj.hasOwnProperty(index)) {
      //       this.roleObj[index] = role[index];
      //     }
      //   }
      // }
    },

    submit() {
      if (!this.loading) {
        this.loading = true;
        // !this.role ? this.store() : this.update();
      }
    },

    store() {
      this.roleObj.store()
        .then(response => {
          //  flash(response)
          this.$emit('stored');
        })
        .finally(() => {
          this.loading = false;
        });
    },

    update() {
      this.roleObj.update(this.role.id)
        .then(response => {
          // flash(response)
          this.$emit('updated');
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
};
</script>
